/************************************************************************
;copyright		:shenzhen coolwaveasia
;filename		:lcd.c
;lcd			:TC802B-01
;control mcu	:w78e52b
;writeby		:dengyihong
;describe		:LCD control
;notice			:
;***********************************************************************/
 #include  "reg52.h"
 #include"../header/global.h" 
void delay_2us(unsigned int  delay_cnt);
///extern  void delay_2us(unsigned int delay_cnt);
/*#define   ROW(x)       (0x80|(x << 0x06))
#define   COL(x)       (x)
#define   LEN(x)       ((x-0x01) << 0x03)


#define   HexDisp(x)   HexDispArray[x]
#define   BYTE_LOW(x)  (x & 0x0F) 
#define   BYTE_HIGH(x) ((x & 0xF0)>>0x04)
// lcd bit define
sbit     LCD_RW = P2^2;
sbit     LCD_RS = P2^1;
sbit     LCD_EN = P2^0;
#define  LCD_DATA P0  */
//#include "..\header\lcd.h"
 #define   LEN_MASK     0x38
#define   COL_MASK     0x07
#define   ROW_MASK     0xC0
#define   ROW_COL      (ROW_MASK|COL_MASK)
	
#define  LCD_DATA P0
sbit     LCD_RW = P2^2;
sbit     LCD_RS = P2^1;
sbit     LCD_EN = P2^0;
void delay_2us(unsigned int  delay_cnt);
 void ini_lcd(void);
void lcd_printf_char(unsigned char  disp_char, unsigned char  row_col);
void lcd_printf_string(unsigned char  *disp_str, char row_len_col);
void lcd_write_reg(unsigned char  command);
void lcd_write_data( char value);
void lcd_wait(void);

/***********************************************************
name:		ini_lcd		
input:		none
output:		none
describe:	ʼLCD	
notice:
creat date: 2008-7-25
creator:	dengyihong
************************************************************/
void ini_lcd(void)
{
    lcd_write_reg(0x38);
    lcd_write_reg(0x38);
    lcd_write_reg(0x38);
    lcd_write_reg(0x08);
    lcd_wait();
    lcd_write_reg(0x01);
    lcd_wait();
    delay_2us(50000);
    
    lcd_write_reg(0x14);
    lcd_wait();
    lcd_write_reg(0x06);
    lcd_wait();
    lcd_write_reg(0x80);
    lcd_wait();
    lcd_write_reg(0x0c);
    lcd_wait();	
}


/***********************************************************
name:		lcd_printf_string	
input:		*disp_str  ---  ʾַͷָ
			row_len_col  ---  ʾʾַ
			row_len_col:
				bit[7:6]: ʾ
				bit[5:3]: ʾַ
				bit[2:0]: ʾַʼ
output:		none
describe:	Ļʾַ		
notice:
creat date: 2008-7-25
creator:	dengyihong
************************************************************/
void lcd_printf_string(unsigned char  *disp_str, char row_len_col)
{
    unsigned char  i = 0;
    unsigned char len = 0;
    
    len = (row_len_col & LEN_MASK) >> 0x03;
    
    lcd_write_reg(row_len_col & ROW_COL);
    lcd_wait();
    
    for(i=0; i<=len; i++)
    {
        lcd_write_data(*disp_str++);
        lcd_wait();	
    }
}


/***********************************************************
name:		lcd_printf_char		
input:		disp_char  ---  Ҫʾַ
			row_col    ---  ʾ
output:		none
describe:	Ļʾһַ		
notice:
creat date: 2008-7-25
creator:	dengyihong
************************************************************/
/*
void lcd_printf_char(U8 disp_char, U8 row_col)
{
    lcd_write_reg(row_col & ROW_COL);
    lcd_wait();
    lcd_write_data(disp_char);
    lcd_wait();	
}
*/

/***********************************************************
name:		lcd_write_reg		
input:		command  ---  Ҫд
output:		none
describe:	дLCD	
notice:
creat date: 2008-7-25
creator:	dengyihong
************************************************************/
void lcd_write_reg(char command)
{
    LCD_DATA = command;		// д
    LCD_RS = 0;
    LCD_RW = 0;
    LCD_EN = 1;
    delay_2us(100);
    LCD_EN = 0;
}


/***********************************************************
name:		lcd_write_data		
input:		value  ---  Ҫд
output:		none
describe:	дݵLCD	
notice:
creat date: 2008-7-25
creator:	dengyihong
************************************************************/
void lcd_write_data(unsigned char  value)
{
   LCD_DATA =  value;		//д
   LCD_RS = 1;
   LCD_RW = 0;
   LCD_EN = 1;
   delay_2us(100);
   LCD_EN = 0; 	
}

/***********************************************************
name:		lcd_wait	
input:		none
output:		none
describe:	ȴLCDڲ	
notice:
creat date: 2008-7-25
creator:	dengyihong
************************************************************/
void lcd_wait(void)
{
    unsigned char value = 0;
       
    do
    {
        LCD_RS = 0;
        LCD_RW = 1;
        LCD_EN = 1;
        value = LCD_DATA;	
        LCD_EN = 0;
    }while(value & 0x80);		// ȴڲ	
}

  /**********************************************************
name:		delay_2us
input:		delay_cnt
output:		none
describe:	delay x*2us
notice:
creat date:	2008-7-24
creator:	dengyihong
**********************************************************/
void delay_2us(unsigned int  delay_cnt)
{
    while(delay_cnt--);
}